** OOP.prg
** object-Oriented Foxpro DBase - April 11, 1990
** by Gregory L. Reichert (c)
**

#DEFINE MaxobjSelf         2
#DEFINE Maxobjects        ((10^MaxobjSelf)-1)

CLEAR ALL
SET TALK OFF
SET SAFETY OFF

*---- Must pass all parameters by reference --------

SET UDFPARMS TO REFERENCE

CLEAR

*---- Declare Instance to object -------

PRIVATE obj, done
DO WHILE .T.

    DO mesg WITH "Select object Type"
    CLEAR
    @ 10,0
    @ ROW()+1, 5 SAY ""
    @ ROW()+1, 5 SAY "        FOXpro++ - Objects for Foxpro "
    @ ROW()+1, 5 SAY "        "
    @ ROW()+1, 5 SAY "        Select one the follows options.  An object is created "
    @ ROW()+1, 5 SAY "    and placed on the screen.  The user then moves the object "
    @ ROW()+1, 5 SAY "    around the screen.  Press the Enter key, and the object and"
    @ ROW()+1, 5 SAY "    its position are saved to a object file (O00.mem), then "
    @ ROW()+1, 5 SAY "    movement is allowed again.  Move to object to a new location,"
    @ ROW()+1, 5 SAY "    and press the Enter key again.  The object file is loaded,"
    @ ROW()+1, 5 SAY "    returning the object to its previously saved state. A third "
    @ ROW()+1, 5 SAY "    pressed of the Enter key, ends the run."
    @ ROW()+1, 5 SAY ""
    @ ROW()+1, 5 SAY "    1.    Dot"
    @ ROW()+1, 5 SAY "    2.    Line"
    @ ROW()+1, 5 SAY "    3.    Worm"
    @ ROW()+1, 5 SAY "    4.    Box"
    @ ROW()+1, 5 SAY "    9.    Exit"
    @ ROW()+1, 5 SAY ""
    @ ROW()+1, 5 SAY ""
    INPUT "Select: " TO ans

    DO mesg WITH "Initializing objects..."
    DO CASE
    CASE ans=9
        EXIT
    CASE ans=1
        obj = dot("",10,0)
    CASE ans=2
        obj = dotline("",0,0,4,0)
    CASE ans=3
        obj = worm("",9)            && Define object Worm
    CASE ans=4
        obj = BOX("", 1,1, 10,10)
    ENDCASE

    DO demo WITH (obj)          && Perform object

    DO mesg WITH "Release objects"
    DO (EVALUATE(obj+'done')) WITH obj           && Destory object

ENDDO
DO mesg WITH "Done"
CLEAR
RETURN


***********************************************************


PROCEDURE demo
    PARAMETER obj


    *---- Perform each method with current object handle ------

    DO mesg WITH "Show object"
    DO (EVALUATE(obj+'show'))  WITH (obj)

    DO mesg WITH "Drag object with Arrow keys"
    DO (EVALUATE(obj+'drag'))  WITH (obj)

    DO mesg WITH "Saving object..."
    DO (EVALUATE(obj+'saveO')) WITH (obj),(obj)

    DO mesg WITH "Continue Dragging"
    DO (EVALUATE(obj+'drag'))  WITH (obj)

    DO mesg WITH "Hide object"
    DO (EVALUATE(obj+'hide'))  WITH (obj)

    DO mesg WITH "Load saved object ... restore position"
    DO (EVALUATE(obj+'loadO')) WITH (obj),(obj)

    DO mesg WITH "Show object"
    DO (EVALUATE(obj+'show'))  WITH (obj)

    DO mesg WITH "Continue Dragging"
    DO (EVALUATE(obj+'drag'))  WITH (obj)

    DO mesg WITH "Hide object"
    DO (EVALUATE(obj+'hide'))  WITH (obj)

    RETURN

PROCEDURE Mesg
    PARAMETER msg
    SET MESSAGE TO msg
    RETURN

    ***************************************************
    *                                                 *
    *       object-Oriented Support Routines          *
    *                                                 *
    ***************************************************

    *  Generates object Reference (Self)
PROCEDURE objref
    PARAMETER VALUE
    RETURN("O"+RIGHT(REPLICATE("0",MaxobjSelf)+LTRIM(STR(VALUE)),MaxobjSelf))


    ** -- Initialize New object Reference
PROCEDURE construct
    PARAMETER Self
    * if no Self is being implied
    IF EMPTY(Self)
        *  search for first unused reference
        PRIVATE x_
        FOR x_ = 0 TO Maxobjects
            IF TYPE(objref(x_))="U"
                EXIT
            ENDIF
        ENDFOR
        *   create reference
        Self       = objref(x_)
        *   check for overflow - Self will = O00
        IF TYPE(Self)#"U"
            ? "Error - Out of object Handles"
            CANCEL
        ENDIF
    ENDIF
    *  initialize object Reference
    PUBLIC (Self)
    RETURN(Self)

    **  Destroy Existing object Reference
PROCEDURE destruct
    PARAMETER Self
    IF ! EMPTY(Self)
        IF TYPE(Self)#"U"
            RELEASE (Self)
        ENDIF
    ENDIF
    RETURN(Self)

PROCEDURE objsave
    PARAMETER Self, to_, asmemo
    IF asmemo
        IF (! EMPTY(ALIAS()) .AND. TYPE(to_)="M")
            SAVE TO MEMO &to_ ALL LIKE &Self.*
        ENDIF
    ELSE
        SAVE TO &to_ ALL LIKE &Self.*
    ENDIF
    RETURN(Self)

PROCEDURE objload
    PARAMETER Self, from_, asmemo
    IF asmemo
        IF (! EMPTY(ALIAS()) .AND. TYPE(to_)="M")
            RESTORE FROM MEMO &from_ ADDITIVE
        ENDIF
    ELSE
        RESTORE FROM &from_ ADDITIVE
    ENDIF
    RETURN(Self)

    *-----------------------------
    *
    *       User-defined objects
    *
    *-----------------------------

    ***--------- Base object -------------

PROCEDURE base
    PARAMETER Self
    = construct(Self)

    PUBLIC (Self+'done'), (Self+'saveo'), (Self+'loado')

    STORE [objSave] TO (Self+'saveo')
    STORE [objLoad] TO (Self+'loado')
    STORE [DoneBase] TO (Self+'done')

    STORE [Base] TO (Self)

    RETURN(Self)

    ***---------- List object ------------

PROCEDURE objlist
    PARAMETER Self, type_, listcnt
    = construct(Self)

    PUBLIC (Self+'Lcnt'),   (Self+'list[listcnt]')
    PUBLIC (Self+'listop'), (Self+'donel')

    STORE listcnt TO (Self+'lcnt')
    STORE [ListEng] TO (Self+'listop')
    STORE [DoneList] TO (Self+'donel')

    PRIVATE x_
    STORE [] TO (Self+'list')
    FOR x_ = 1 TO listcnt
        STORE EVALUATE(type_) TO (self+'list['+STR(x_)+']')
    ENDFOR
    RETURN(Self)


    ***--------- Point object ------------

PROCEDURE POINT
    PARAMETER Self, x, y
    = base(Self)

    PUBLIC (Self+'x'), (Self+'y'), (Self+'done')
    STORE x TO (Self+'x')
    STORE y TO (Self+'y')

    STORE [DonePt] TO (Self+'done')

    STORE [Point] TO (Self)
    RETURN(self)

    *--------- Dot object ----------------

PROCEDURE dot
    PARAMETER Self, x, y
    = POINT(Self,x,y)

    PUBLIC (Self+'show'),   (Self+'hide'), (Self+'move')
    PUBLIC (Self+'moveto'), (Self+'drag'), (Self+'done'), (Self+'SavePos')

    STORE [ShowDot] TO (Self+'show')
    STORE [HideDot] TO (Self+'hide')
    STORE [Move] TO (Self+'move')
    STORE [Moveto] TO (Self+'moveto')
    STORE [Drag] TO (Self+'drag')
    STORE [DoneDot] TO (Self+'done')
    STORE [SavePos] TO (Self+'SavePos')
    STORE [RestPos] TO (Self+'RestPos')

    STORE [Dot] TO (self)
    RETURN(Self)

    ***--------- Line object ------------

PROCEDURE dotline
    PARAMETER Self,frx_,fry_,tox_,toy_
    = dot(Self,frx_,fry_)

    PUBLIC (Self+'tx'),    (Self+'ty')
    PUBLIC (Self+'move'),  (Self+'show'),  (Self+'hide')
    PUBLIC (Self+'saveo'), (Self+'loado'), (Self+'done')

    STORE tox_ TO (Self+'tx')
    STORE toy_ TO (Self+'ty')

    STORE [MoveL] TO (Self+'move')
    STORE [ShowL] TO (Self+'show')
    STORE [HideL] TO (Self+'hide')
    STORE [SaveL] TO (Self+'saveo')
    STORE [LoadL] TO (Self+'loado')
    STORE [DoneL] TO (Self+'done')

    STORE [Line] TO (self)

    = objlist(Self,[Dot("",x_,Fry_)],(tox_-frx_)+1)

    RETURN(Self)

    ***------- Worm Line object -----------

PROCEDURE worm
    PARAMETER Self, LEN
    = dotline(Self,1,0,LEN,0)

    PUBLIC (Self+'move'), (Self+'done')

    STORE [MoveWorm] TO (Self+'move')
    STORE [DoneWorm] TO (Self+'done')

    STORE [Worm] TO (self)
    RETURN(Self)

    ***------- Box object ------------------

PROCEDURE BOX
    PARAMETER Self, t,l, D,W

    Self         = Dot(Self, l,t )

    PUBLIC (self+'show'), (self+'hide'), (self+'done'), (self+'move')
    PUBLIC (self+'Load'), (self+'Make')
    PUBLIC (self+'d'), (self+'w')

    STORE D TO (self+'d')
    STORE W TO (self+'w')
    STORE [BoxDone] TO (self+'done')
    STORE [BoxShow] TO (self+'show')
    STORE [BoxHide] TO (Self+'Hide')
    STORE [BoxMove] TO (self+'Move')
    STORE [BOXLoad] TO (self+'Loado')
    STORE [BoxMake] TO (self+'Make')
    STORE [Box] TO (self)

    DO (EVALUATE(self+'Make')) WITH Self

    RETURN(self)


    *----------------------------
    *       Support routines
    *----------------------------

PROCEDURE onscreen
    PARAMETER osx_, osy_
    RETURN((osx_>=0) .AND. (osx_<=WROWS()) ;
        .AND. (osy_>=0) .AND. (osy_<=WCOLS()))

    *----------------------------
    *       Base object Methods
    *----------------------------

PROCEDURE donebase
    PARAMETER Self
    RELEASE (Self+'done'), (Self+'saveo'), (Self+'loado')
    = destruct(Self)
    RETURN

    *----------------------------
    *       List object
    *----------------------------

PROCEDURE listeng
    PARAMETER Self, oper, p0,p1,p2,p3,p4,p5,p6,p7,p8,p9
    PRIVATE pcnt, oself, x_, tpara
    pcnt = PARAMETERS()
    oself = self
    tpara = SUBSTR(",p0,p1,p2,p3,p4,p5,p6,p7,p8,p9",1,(pcnt-2)*3)
    FOR x_ = 1 TO EVALUATE(oSelf+'lcnt')
        STORE EVALUATE(oself+'list['+STR(x_)+']') TO self
        DO (EVALUATE(self+oper)) WITH (self) &tpara
    ENDFOR
    self = oself
    RETURN


PROCEDURE donelist
    PARAMETER Self, oper
    DO (EVALUATE(Self+'ListOp')) WITH (Self),(oper)
    RELEASE (Self+'lcnt'), (Self+'list'), (Self+'listop'), (Self+'donel')
    =destruct(Self)
    RETURN


    *----------------------------
    *       Point object Methods
    *----------------------------

PROCEDURE donept
    PARAMETER Self
    RELEASE (Self+'x'), (Self+'y'), (Self+'done')
    DO donebase WITH (Self)
    RETURN

    *----------------------------
    *       Dot object Methods
    *----------------------------

PROCEDURE showdot
    PARAMETER Self
    IF onscreen(EVALUATE(Self+'x'), EVALUATE(Self+'y'))
        @ EVALUATE(Self+'x') , EVALUATE(Self+'y') SAY "*"
    ENDIF
    RETURN

PROCEDURE hidedot
    PARAMETER Self
    IF onscreen(EVALUATE(Self+'x'), EVALUATE(Self+'y'))
        @ EVALUATE(Self+'x') , EVALUATE(Self+'y') SAY " "
    ENDIF
    RETURN

PROCEDURE MOVE
    PARAMETER Self, newx, newy
    DO (EVALUATE(self+'moveto')) WITH (Self),(EVALUATE(Self+'x')+newx),(EVALUATE(Self+'y')+newy)
    RETURN

PROCEDURE moveto
    PARAMETER Self, newx, newy
    DO (EVALUATE(Self+'hide')) WITH (Self)
    STORE newx TO (Self+'x')
    STORE newy TO (Self+'y')
    DO (EVALUATE(Self+'show')) WITH (Self)
    RETURN

PROCEDURE drag
    PARAMETER Self

    PRIVATE ikey, x_, y_

    PRIVATE upkey, downkey, leftkey, rightkey, quitkey
    upkey       =  5
    downkey     = 24
    leftkey     = 19
    rightkey    =  4
    quitkey     = 13            && Enter key
    ESCAPE      = 27

    DO WHILE .T.
        @ 0,0 SAY ""
        ikey = INKEY(0)

        STORE 0 TO x_,y_
        DO CASE
        CASE ikey=ESCAPE
            EXIT
        CASE ikey=upkey
            x_=x_-1
        CASE ikey=downkey
            x_=x_+1
        CASE ikey=leftkey
            y_=y_-1
        CASE ikey=rightkey
            y_=y_+1
        CASE ikey=quitkey
            EXIT
        OTHERWISE
            LOOP
        ENDCASE
        DO (EVALUATE(Self+'move')) WITH (Self),x_,y_
    ENDDO
    RETURN

PROCEDURE SavePos
    PARAMETER Self,x,y
    STORE x TO (Self+'X')
    STORE y TO (Self+'Y')
    RETURN

PROCEDURE RestPos
    PARAMETER Self, x, y
    STORE (Self+'X') TO x
    STORE (Self+'Y') TO y
    RETURN


PROCEDURE donedot
    PARAMETER Self
    RELEASE (Self+'hide'), (Self+'show'),   (Self+'drag')
    RELEASE (Self+'move'), (Self+'moveto'), (Self+'done')
    RELEASE (Self+'SavePos')

    DO donept WITH (Self)
    RETURN

    *-----------------------------
    *       Line object Methods
    *-----------------------------

PROCEDURE hidel
    PARAMETER Self
    DO (EVALUATE(Self+'ListOp')) WITH (Self),"Hide"
    RETURN

PROCEDURE showl
    PARAMETER Self
    DO (EVALUATE(Self+'ListOp')) WITH (Self),"Show"
    RETURN

PROCEDURE movel
    PARAMETER Self, newx_ newy_
    DO (EVALUATE(Self+'ListOp')) WITH (Self),"Move", newx_, newy_
    RETURN

PROCEDURE savel
    PARAMETER Self, to_, asmemo
    DO (EVALUATE(Self+'ListOp')) WITH (Self),"SaveO","&"+"self"
    DO objsave WITH (Self),to_+".FBJ"
    RETURN


PROCEDURE loadl
    PARAMETER Self, from_, asmemo
    DO objload WITH (Self),from_+".FBJ"
    DO (EVALUATE(Self+'ListOp')) WITH (Self),"LoadO","&"+"self"
    RETURN

PROCEDURE donel
    PARAMETER Self
    DO donelist WITH (Self),"Done"
    RELEASE (Self+'tx'),   (Self+'ty')
    RELEASE (Self+'move'), (Self+'hide'), (Self+'done'), (Self+'show')
    DO donedot WITH (Self)
    RETURN

    *-----------------------------
    *       Worm object Methods
    *-----------------------------

PROCEDURE moveworm
    PARAMETER Self, newx_ newy_
    PRIVATE x_, MOVE, sx, oldx, oldy
    STORE 0 TO oldx, oldy
    FOR x_  = 1 TO EVALUATE(Self+'lcnt')
        STORE EVALUATE(Self+'list['+STR(x_)+']') TO sx
        STORE EVALUATE(sx+'x') TO oldx
        STORE EVALUATE(sx+'y') TO oldy
        IF x_ = EVALUATE(Self+'x')
            newx_ = oldx + newx_
            newy_ = oldy + newy_
        ENDIF
        DO (EVALUATE(sx+'moveto')) WITH (sx),(newx_),(newy_)
        newx_ = oldx
        newy_ = oldy
    ENDFOR
    RETURN

PROCEDURE doneworm
    PARAMETER Self
    RELEASE (Self+'move'), (Self+'done')
    DO donel WITH Self
    RETURN(Self)

    *--- box object methods.

PROCEDURE BoxDone
    PARAMETER Self
    RELEASE (self+'show'), (self+'hide'), (self+'done'), (self+'Load')
    RELEASE (self+'Make'), (self+'move')
    RELEASE (self+'w'), (self+'d')
    RELEASE WINDOW (self)
    DO donedot WITH self
    RETURN(self)

PROCEDURE BoxShow
    PARAMETER self
    IF WEXIST(self)
        ACTIVATE WINDOW (self)
    ENDIF
    RETURN

PROCEDURE BoxHide
    PARAMETER self
    IF WEXIST(self)
        DEACTIVATE WINDOW (self)
    ENDIF
    RETURN

PROCEDURE BoxMove
    PARAMETER self, NewX, NewY
    MOVE WINDOW (self) BY NewX, NewY
    DO (EVALUATE(Self+'SavePos')) WITH (self), WLCOL(self), WLROW(self)
    RETURN

PROCEDURE BoxLoad
    PARAMETER Self, from_, asmemo
    DO objload WITH (Self),from_
    IF WEXIST(self)
        MOVE WINDOW (self) TO (EVALUATE(self+'Y')), (EVALUATE(self+'X'))
    ELSE
        DO (EVALUATE(self+'Make')) WITH (self)
    ENDIF
    DO (EVALUATE(self+'Show')) WITH (self)
    RETURN

PROCEDURE BoxMake
    PARAMETER self
    DEFINE WINDOW (self) ;
        FROM EVALUATE(self+'Y'), ;
        EVALUATE(self+'X') ;
        TO EVALUATE(self+'Y')+EVALUATE(self+'d'), ;
        EVALUATE(self+'X')+EVALUATE(self+'w')
    RETURN

    * EOF OOP.prg

